/***************************************************************************
 *   Copyright (C) 2006 by Michael Andreen                                 *
 *   andreen@student.chalmers.se                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

#ifndef __MODELS_H__
#define __MODELS_H__

class SortAction;
class GeneOrder;

namespace Models {

class ModelImpl {
	public:
		virtual ~ModelImpl();

		virtual double score(const SortAction& sa, const GeneOrder& go);

		virtual const char* name();
};


class X : public ModelImpl {
	public:
		double score(const SortAction& sa, const GeneOrder& go);

		const char* name();
};

class Zipper : public ModelImpl {
	public:
		double score(const SortAction& sa, const GeneOrder& go);

		const char* name();
};

class Cloud : public ModelImpl {
	public:
		double score(const SortAction& sa, const GeneOrder& go);

		const char* name();
};

class FatX : public ModelImpl {
	public:
		double score(const SortAction& sa, const GeneOrder& go);

		const char* name();
};

}

#endif
